//
//  HWAudioPlayerManger.m
//  HWTableView
//
//  Created by wangqibin on 2018/4/18.
//  Copyright © 2018年 qibin wang. All rights reserved.
//

#import "HWAudioPlayerManger.h"
#import <AVFoundation/AVFoundation.h>

@interface HWAudioPlayerManger ()

@property (nonatomic, strong) AVSpeechSynthesizer *synthesizer;

@end

@implementation HWAudioPlayerManger

+ (instancetype)shareManager
{
    static HWAudioPlayerManger *instance;

    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[self alloc] init];
        instance.synthesizer = [[AVSpeechSynthesizer alloc] init];
    });

    return instance;
}

- (void)playWithString:(NSString *)string
{
    if (self.synthesizer.isSpeaking) {
        [self.synthesizer stopSpeakingAtBoundary:AVSpeechBoundaryImmediate];
    }

    AVSpeechUtterance *utterance = [[AVSpeechUtterance alloc] initWithString:string];
    utterance.voice = [AVSpeechSynthesisVoice voiceWithLanguage:@"zh-CN"];
    [self.synthesizer speakUtterance:utterance];
}

@end
